--[[

	Function File for Paint Lite 0.2.0
	----------------------------------
	Provides a useful sunctions and variables for app work
	
	Last Edit: 2019.12.20

--]]

About = {
	Version = "0.2.0",
	Date = "2019.12.20",
	Author = "MasterMen",
}


Arial = Font.load("Fonts/Arial.TTF")
Arial:setPixelSizes(11,11)

Black = Color.new(0	,0	,0)
White = Color.new(255	,255	,255)
Red = Color.new(255	,0	,0)
Green = Color.new(0	,255	,0)
Blue = Color.new(0	,0	,255)
Yellow = Color.new(255	,255	,0)

ScreenCFG = io.open("My Drawings/ScreenCount.cfg", "r")
ScreenCount = tonumber(ScreenCFG:read())
ScreenCFG:close()

-- Old saving system (I'd make it work with dates, but LuaPlayer 0.20 doesn't have it)
IsSaving = false
function TakeScreenshot()
	--IsSaving = true
	--State = "Paint"
	screen:save("My Drawings/Save"..ScreenCount..".png")
	ScreenCount = ScreenCount + 1
	ScreenCFG = io.open("My Drawings/ScreenCount.cfg", "w")
	ScreenCFG:write(ScreenCount)
	ScreenCFG:close()
	--IsSaving = false
end

function ChangePaletteColor(Color, ColorID)
	if Color == "A" then
		if ColorID == 1 then
			AColor = Palette.Color1
			Sel.LX = 3
			Sel.LY = 61
		elseif ColorID == 2 then
			AColor = Palette.Color2
			Sel.LX = 16
			Sel.LY = 61
		elseif ColorID == 3 then
			AColor = Palette.Color3
			Sel.LX = 29
			Sel.LY = 61
		elseif ColorID == 4 then
			AColor = Palette.Color4
			Sel.LX = 42
			Sel.LY = 61
			
		elseif ColorID == 5 then
			AColor = Palette.Color5
			Sel.LX = 3
			Sel.LY = 73
		elseif ColorID == 6 then
			AColor = Palette.Color6
			Sel.LX = 16
			Sel.LY = 73
		elseif ColorID == 7 then
			AColor = Palette.Color7
			Sel.LX = 29
			Sel.LY = 73
		elseif ColorID == 8 then
			AColor = Palette.Color8
			Sel.LX = 42
			Sel.LY = 73
			
		elseif ColorID == 9 then
			AColor = Palette.Color9
			Sel.LX = 3
			Sel.LY = 85
		elseif ColorID == 10 then
			AColor = Palette.Color10
			Sel.LX = 16
			Sel.LY = 85
		elseif ColorID == 11 then
			AColor = Palette.Color11
			Sel.LX = 29
			Sel.LY = 85
		elseif ColorID == 12 then
			AColor = Palette.Color12
			Sel.LX = 42
			Sel.LY = 85
			
		elseif ColorID == 13 then
			AColor = Palette.Color13
			Sel.LX = 3
			Sel.LY = 97
		elseif ColorID == 14 then
			AColor = Palette.Color14
			Sel.LX = 16
			Sel.LY = 97
		elseif ColorID == 15 then
			AColor = Palette.Color15
			Sel.LX = 29
			Sel.LY = 97
		elseif ColorID == 16 then
			AColor = Palette.Color16
			Sel.LX = 42
			Sel.LY = 97
			
		elseif ColorID == 17 then
			AColor = Palette.Color17
			Sel.LX = 3
			Sel.LY = 109
		elseif ColorID == 18 then
			AColor = Palette.Color18
			Sel.LX = 16
			Sel.LY = 109
		elseif ColorID == 19 then
			AColor = Palette.Color19
			Sel.LX = 29
			Sel.LY = 109
		elseif ColorID == 20 then
			AColor = Palette.Color20
			Sel.LX = 42
			Sel.LY = 109
			
		elseif ColorID == 21 then
			AColor = Palette.Color21
			Sel.LX = 3
			Sel.LY = 121
		elseif ColorID == 22 then
			AColor = Palette.Color22
			Sel.LX = 16
			Sel.LY = 121
		elseif ColorID == 23 then
			AColor = Palette.Color23
			Sel.LX = 29
			Sel.LY = 121
		elseif ColorID == 24 then
			AColor = Palette.Color24
			Sel.LX = 42
			Sel.LY = 121
			
		elseif ColorID == 25 then
			AColor = Palette.Color25
			Sel.LX = 3
			Sel.LY = 133
		elseif ColorID == 26 then
			AColor = Palette.Color26
			Sel.LX = 16
			Sel.LY = 133
		elseif ColorID == 27 then
			AColor = Palette.Color27
			Sel.LX = 29
			Sel.LY = 133
		elseif ColorID == 28 then
			AColor = Palette.Color28
			Sel.LX = 42
			Sel.LY = 133
			
		elseif ColorID == 29 then
			AColor = Palette.Color29
			Sel.LX = 3
			Sel.LY = 145
		elseif ColorID == 30 then
			AColor = Palette.Color30
			Sel.LX = 16
			Sel.LY = 145
		elseif ColorID == 31 then
			AColor = Palette.Color31
			Sel.LX = 29
			Sel.LY = 145
		elseif ColorID == 32 then
			AColor = Palette.Color32
			Sel.LX = 42
			Sel.LY = 145
			
		elseif ColorID == 33 then
			AColor = Palette.Color33
			Sel.LX = 3
			Sel.LY = 157
		elseif ColorID == 34 then
			AColor = Palette.Color34
			Sel.LX = 16
			Sel.LY = 157
		elseif ColorID == 35 then
			AColor = Palette.Color35
			Sel.LX = 29
			Sel.LY = 157
		elseif ColorID == 36 then
			AColor = Palette.Color36
			Sel.LX = 42
			Sel.LY = 157
			
		elseif ColorID == 37 then
			AColor = Palette.Color37
			Sel.LX = 3
			Sel.LY = 169
		elseif ColorID == 38 then
			AColor = Palette.Color38
			Sel.LX = 16
			Sel.LY = 169
		elseif ColorID == 39 then
			AColor = Palette.Color39
			Sel.LX = 29
			Sel.LY = 169
		elseif ColorID == 40 then
			AColor = Palette.Color40
			Sel.LX = 42
			Sel.LY = 169
			
		elseif ColorID == 41 then
			AColor = Palette.Color41
			Sel.LX = 3
			Sel.LY = 181
		elseif ColorID == 42 then
			AColor = Palette.Color42
			Sel.LX = 16
			Sel.LY = 181
		elseif ColorID == 43 then
			AColor = Palette.Color43
			Sel.LX = 29
			Sel.LY = 181
		elseif ColorID == 44 then
			AColor = Palette.Color44
			Sel.LX = 42
			Sel.LY = 181
			
		elseif ColorID == 45 then
			AColor = Palette.Color45
			Sel.LX = 3
			Sel.LY = 193
		elseif ColorID == 46 then
			AColor = Palette.Color46
			Sel.LX = 16
			Sel.LY = 193
		elseif ColorID == 47 then
			AColor = Palette.Color47
			Sel.LX = 29
			Sel.LY = 193
		elseif ColorID == 48 then
			AColor = Palette.Color48
			Sel.LX = 42
			Sel.LY = 193
			
		end
	elseif Color == "B" then
		if ColorID == 1 then
			BColor = Palette.Color1
			Sel.RX = 3
			Sel.RY = 61
		elseif ColorID == 2 then
			BColor = Palette.Color2
			Sel.RX = 16
			Sel.RY = 61
		elseif ColorID == 3 then
			BColor = Palette.Color3
			Sel.RX = 29
			Sel.RY = 61
		elseif ColorID == 4 then
			BColor = Palette.Color4
			Sel.RX = 42
			Sel.RY = 61
			
		elseif ColorID == 5 then
			BColor = Palette.Color5
			Sel.RX = 3
			Sel.RY = 73
		elseif ColorID == 6 then
			BColor = Palette.Color6
			Sel.RX = 16
			Sel.RY = 73
		elseif ColorID == 7 then
			BColor = Palette.Color7
			Sel.RX = 29
			Sel.RY = 73
		elseif ColorID == 8 then
			BColor = Palette.Color8
			Sel.RX = 42
			Sel.RY = 73
			
		elseif ColorID == 9 then
			BColor = Palette.Color9
			Sel.RX = 3
			Sel.RY = 85
		elseif ColorID == 10 then
			BColor = Palette.Color10
			Sel.RX = 16
			Sel.RY = 85
		elseif ColorID == 11 then
			BColor = Palette.Color11
			Sel.RX = 29
			Sel.RY = 85
		elseif ColorID == 12 then
			BColor = Palette.Color12
			Sel.RX = 42
			Sel.RY = 85
			
		elseif ColorID == 13 then
			BColor = Palette.Color13
			Sel.RX = 3
			Sel.RY = 97
		elseif ColorID == 14 then
			BColor = Palette.Color14
			Sel.RX = 16
			Sel.RY = 97
		elseif ColorID == 15 then
			BColor = Palette.Color15
			Sel.RX = 29
			Sel.RY = 97
		elseif ColorID == 16 then
			BColor = Palette.Color16
			Sel.RX = 42
			Sel.RY = 97
			
		elseif ColorID == 17 then
			BColor = Palette.Color17
			Sel.RX = 3
			Sel.RY = 109
		elseif ColorID == 18 then
			BColor = Palette.Color18
			Sel.RX = 16
			Sel.RY = 109
		elseif ColorID == 19 then
			BColor = Palette.Color19
			Sel.RX = 29
			Sel.RY = 109
		elseif ColorID == 20 then
			BColor = Palette.Color20
			Sel.RX = 42
			Sel.RY = 109
			
		elseif ColorID == 21 then
			BColor = Palette.Color21
			Sel.RX = 3
			Sel.RY = 121
		elseif ColorID == 22 then
			BColor = Palette.Color22
			Sel.RX = 16
			Sel.RY = 121
		elseif ColorID == 23 then
			BColor = Palette.Color23
			Sel.RX = 29
			Sel.RY = 121
		elseif ColorID == 24 then
			BColor = Palette.Color24
			Sel.RX = 42
			Sel.RY = 121
			
		elseif ColorID == 25 then
			BColor = Palette.Color25
			Sel.RX = 3
			Sel.RY = 133
		elseif ColorID == 26 then
			BColor = Palette.Color26
			Sel.RX = 16
			Sel.RY = 133
		elseif ColorID == 27 then
			BColor = Palette.Color27
			Sel.RX = 29
			Sel.RY = 133
		elseif ColorID == 28 then
			BColor = Palette.Color28
			Sel.RX = 42
			Sel.RY = 133
			
		elseif ColorID == 29 then
			BColor = Palette.Color29
			Sel.RX = 3
			Sel.RY = 145
		elseif ColorID == 30 then
			BColor = Palette.Color30
			Sel.RX = 16
			Sel.RY = 145
		elseif ColorID == 31 then
			BColor = Palette.Color31
			Sel.RX = 29
			Sel.RY = 145
		elseif ColorID == 32 then
			BColor = Palette.Color32
			Sel.RX = 42
			Sel.RY = 145
			
		elseif ColorID == 33 then
			BColor = Palette.Color33
			Sel.RX = 3
			Sel.RY = 157
		elseif ColorID == 34 then
			BColor = Palette.Color34
			Sel.RX = 16
			Sel.RY = 157
		elseif ColorID == 35 then
			BColor = Palette.Color35
			Sel.RX = 29
			Sel.RY = 157
		elseif ColorID == 36 then
			BColor = Palette.Color36
			Sel.RX = 42
			Sel.RY = 157
			
		elseif ColorID == 37 then
			BColor = Palette.Color37
			Sel.RX = 3
			Sel.RY = 169
		elseif ColorID == 38 then
			BColor = Palette.Color38
			Sel.RX = 16
			Sel.RY = 169
		elseif ColorID == 39 then
			BColor = Palette.Color39
			Sel.RX = 29
			Sel.RY = 169
		elseif ColorID == 40 then
			BColor = Palette.Color40
			Sel.RX = 42
			Sel.RY = 169
			
		elseif ColorID == 41 then
			BColor = Palette.Color41
			Sel.RX = 3
			Sel.RY = 181
		elseif ColorID == 42 then
			BColor = Palette.Color42
			Sel.RX = 16
			Sel.RY = 181
		elseif ColorID == 43 then
			BColor = Palette.Color43
			Sel.RX = 29
			Sel.RY = 181
		elseif ColorID == 44 then
			BColor = Palette.Color44
			Sel.RX = 42
			Sel.RY = 181
		elseif ColorID == 45 then
			BColor = Palette.Color45
			Sel.RX = 3
			Sel.RY = 193
		elseif ColorID == 46 then
			BColor = Palette.Color46
			Sel.RX = 16
			Sel.RY = 193
		elseif ColorID == 47 then
			BColor = Palette.Color47
			Sel.RX = 29
			Sel.RY = 193
		elseif ColorID == 48 then
			BColor = Palette.Color48
			Sel.RX = 42
			Sel.RY = 193
		end
	end
end




function DetermineColor(ColID)
	-- L Trigger - Left Color - AColor
	-- R Trigger - Right Color - BColor
	if pad:l() then
		ChangePaletteColor("A", ColID)
	elseif pad:r() then
		ChangePaletteColor("B", ColID)
	end
end