--[[

	MenuClass File for Paint Lite 0.2.0
	----------------------------------
	A Main Menu where you can run an app or go to the settings or information or gallery.
	
	Last Edit: 2019.12.20

--]]

-- Loaded from "StartUp.lua"

Button = {
	Start = Image.load("Resources/Style/"..Config.Theme.."/Buttons/Start.png"),               
	Info = Image.load("Resources/Style/"..Config.Theme.."/Buttons/Info.png"), 
	Selector = Image.load("Resources/Style/"..Config.Theme.."/Buttons/Selector.png"),
	Settings = Image.load("Resources/Style/"..Config.Theme.."/Buttons/SettingsLocked.png"),
	Gallery = Image.load("Resources/Style/"..Config.Theme.."/Buttons/GalleryLocked.png"),
	Back = Image.load("Resources/Style/"..Config.Theme.."/Buttons/Back.png"),
}

OtherButton = {
	-- Selected Buttons
	PageShowSel = Image.load("Resources/Style/"..Config.Theme.."/Settings/PageShowSel.png"),
	SmallButtonSel = Image.load("Resources/Style/"..Config.Theme.."/Settings/SmallButtonSel.png"),
	BigSel = Image.load("Resources/Style/"..Config.Theme.."/Settings/BigSelection.png"),
	
	-- UnSelected Buttons
	PageShow = Image.load("Resources/Style/"..Config.Theme.."/Settings/PageShow.png"),
	SmallButton = Image.load("Resources/Style/"..Config.Theme.."/Settings/SmallButton.png"),
	Big = Image.load("Resources/Style/"..Config.Theme.."/Settings/Big.png"),
	
	SelON = Image.load("Resources/Style/"..Config.Theme.."/Settings/SelectorON.png"),
	SelOFF = Image.load("Resources/Style/"..Config.Theme.."/Settings/SelectorOFF.png"),
	
	Counter = Image.load("Resources/Style/"..Config.Theme.."/Settings/Counter.png"),
	
	
	
}

-- I'm still not sure about "Sprite" name of pictures... I wanna change it to something new and nice.
Sprite = {
	Logo = Image.load("Resources/Style/"..Config.Theme.."/Logo.png"),
	Wires = Image.load("Resources/Main/Wires.png"),
	Circles = Image.load("Resources/Main/NineCircles.png"),
	
	SettingPanel = Image.load("Resources/Style/"..Config.Theme.."/Settings/ListBox.png"),
	Slider1x = Image.load("Resources/Style/"..Config.Theme.."/Settings/Slider1x.png"),
	--LeftSelection = Image.load("Resources/Style/"..Config.Theme.."/Settings/Selection/LeftSel.png"),
	--RightSelection = Image.load("Resources/Style/"..Config.Theme.."/Settings/Selection/RightSel.png"),
}

SelX = 90
MenuIndex = 1
-- 1 = Start
-- 2 = Info
-- 3 = Settings

-- BIG Thanks to Exnonull :D
-- This thing is awesome...
pressed={
	left=false,
	up=false,
	right=false,
	down=false,
	r=false,
	l=false,
	start=false,
	select=false,
	cross=false,
	triangle=false,
	square=false,
	circle=false
}

ExtTi = 10

WarningTimer = 0
-- Limit = 50

while true do
	pad = Controls.read()
	screen:clear(StyleInfo.BackColor)
	
	ExtTi = ExtTi - 1
	if ExtTi < 0 then ExtTi = 0 end
	if WarningTimer > 0 then
		WarningTimer = WarningTimer - 1
	end
	
	if pad:left() then
		if pressed.left == false then
			pressed.left = true
			MenuIndex = MenuIndex - 1
			if MenuIndex < 1 then MenuIndex = 4 end
		end
	else
		pressed.left = false
	end
	
	if pad:right() then
		if pressed.right == false then
			pressed.right = true
			MenuIndex = MenuIndex + 1
			if MenuIndex > 4 then MenuIndex = 1 end
		end
	else
		pressed.right = false
	end
	
	if pad:cross() then
		if ExtTi == 0 then
			if MenuIndex == 1 then
				Sprite = nil
				dofile("PaintClass.lua")
			elseif MenuIndex == 2 then
				--dofile("GalleryClass.lua")
				WarningTimer = 38
			elseif MenuIndex == 3 then
				--dofile("SettingClass.lua")
				WarningTimer = 38
			elseif MenuIndex == 4 then
				dofile("InfoClass.lua")
			end
		end
	end
	
	screen:blit(128,35,Sprite.Logo)
	
	screen:blit(80-50,177,Button.Start)
	screen:blit(185-50,177,Button.Gallery)
	screen:blit(290-50,177,Button.Settings)
	screen:blit(395-50,177,Button.Info)
	screen:blit(SelX,177,Button.Selector)
	
	if MenuIndex == 1 then SelX = 80-50
	elseif MenuIndex == 2 then SelX = 185-50
	elseif MenuIndex == 3 then SelX = 290-50
	elseif MenuIndex == 4 then SelX = 395-50
	end
	
	if WarningTimer > 0 then screen:fontPrint(Arial,152,238,"Will be avalable in the next versions.",StyleInfo.FontColor) end
	
	-- MN later, it's only a testing
	screen:fontPrint(Arial,12,262,"Welcome, "..Config.Nick,StyleInfo.FontColor)
	
	screen.flip()
	screen.waitVblankStart()
end