--[[

	PaintClass File for Paint Lite 0.2.0
	----------------------------------
	The app file.
	
	Last Edit: 2019.12.20

--]]

-- оТСтуП :D

dofile("Data/Editor.cfg")
dofile("Data/Palette.cfg")

Cursor = {
	X = 10,
	Y = 10,
	Speed = 3,
	
	StickSwap = false,
	Tool = "Pencil",
	-- Pencil
	-- Eraser
	-- Fill
	-- Line
	-- Square
	-- Circle
	
	Thickness = 1,
	
	Form = "Square",
	
	AColor = {
		R = 255,
		G = 0,
		B = 0
	},
	BColor = {
		R = 0,
		G = 0,
		B = 255
	},
	LastColor = Color.new(255,255,0),
	IMG = {
		-- Pyramid, eh?
		Pencil = nil,
		Eraser = nil,
		FillTool = nil,
		LineTool = nil,
		SquareTool = nil,
		CircleTool = nil,
		ColorPickTool = nil,
		SelectionTool = nil,
		MovingSelectionTool = nil,
		MovingTool = nil,
		Cursor = nil,
	},
	Fill = {
		x0 = 50,
		y0 = 50,
		x1 = 100,
		y1 = 100,
		w = 25,
		h = 25,
	},
}

Cursor.X = Editor.StartX
Cursor.Y = Editor.StartY

AColor = Color.new(Cursor.AColor.R, Cursor.AColor.G, Cursor.AColor.B)
BColor = Color.new(Cursor.BColor.R, Cursor.BColor.G, Cursor.BColor.B)
BGColor = Color.new(Editor.FillColorR, Editor.FillColorG, Editor.FillColorB)

BG = {
	Color = {
		R = 0,
		G = 0,
		B = 0,
	},
}

Style = "White"


-- Picture Importing





-- Load Cursor Images using Config Data
Cursor.IMG.Pencil = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Pencil.png")
Cursor.IMG.Eraser = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Eraser.png")
Cursor.IMG.FillTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Fill.png")
Cursor.IMG.LineTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Line.png")
Cursor.IMG.SquareTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Square.png")
Cursor.IMG.CircleTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Circle.png")
Cursor.IMG.ColorPickTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/ColorPick.png")
Cursor.IMG.SelectionTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Selection.png")
Cursor.IMG.MovingSelectionTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/MoveSelection.png")
Cursor.IMG.MovingTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Move.png")
Cursor.IMG.Cursor = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Cursor.png")
dofile("Resources/ToolPack/"..Config.ToolPack.."/Info.cfg")


-- Paint Lite Style

Sprite = {
	PanelTool = Image.load("Resources/Style/"..Config.Theme.."/PanelTools.png"),
	PanelColor = Image.load("Resources/Style/"..Config.Theme.."/PanelColors.png"),
	PanelParams = Image.load("Resources/Style/"..Config.Theme.."/PanelParams.png"),
	PanelSpeed = Image.load("Resources/Style/"..Config.Theme.."/PanelSpeed.png"),
	SpeedNon = Image.load("Resources/Style/"..Config.Theme.."/PanelSpeedNon.png"),
	PanelThickness = Image.load("Resources/Style/"..Config.Theme.."/PanelThickness.png"),
	ThicknessNon = Image.load("Resources/Style/"..Config.Theme.."/PanelThicknessNon.png"),
	
	Locker = Image.load("Resources/Style/"..Config.Theme.."/Icons/Locker.png"),
	
	Icon = {
		Pencil = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Pencil.png"),
		Eraser = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Eraser.png"),
		FillTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Fill.png"),
		LineTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Line.png"),
		SquareTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Square.png"),
		CircleTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Circle.png"),
		ColorPickTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/ColorPick.png"),
		SelectionTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Selection.png"),
		MovingSelectionTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/MoveSelection.png"),
		MovingTool = Image.load("Resources/ToolPack/"..Config.ToolPack.."/Icon/Move.png"),
	},
	
	SpeedIcons = {
		Fast = Image.load("Resources/Style/"..Config.Theme.."/Speed/Fast.png"),
		Normal = Image.load("Resources/Style/"..Config.Theme.."/Speed/Normal.png"),
		Slow = Image.load("Resources/Style/"..Config.Theme.."/Speed/Slow.png"),
		SuperSlow = Image.load("Resources/Style/"..Config.Theme.."/Speed/SuperSlow.png"),
	}
}

-- An image where we will draw
Alpha = Image.load("Resources/Main/Alpha.png")
AlphaTool = Image.createEmpty(480, 272)
-- There will be Layers that you will be able to hide and show
AlphaTool = Image.load("Resources/Main/Alpha.png")

-- Some Useful Functions
function DrawRect(x0, y0, x1, x1, Color)
	Alpha:drawLine(x0,y0,x1,y0,Color)
	Alpha:drawLine(x0,y0,x0,y1,Color)
	Alpha:drawLine(x0,y1,x1,y1,Color)
	Alpha:drawLine(x1,y0,x1,y1,Color)
end

function DrawFillRect(sx,sy,w,h,Color)
	Alpha:fillRect(sx,sy,w,h,Color)
end

function screen_SetPixel(X, Y, Color)
	screen:fillRect(X, Y, 1, 1, Color)
end

function Alpha_SetPixel(X, Y, Color)
	Alpha:fillRect(X, Y, 1, 1, Color)
end

-- Screenshoot Function here :P

Sensity = 2
State = "Paint"
StickMod = 1
Timer = {
	PanelSpeed = 0,
	PanelThickness = 0,
}

ScreenshotType = "HUD1"
-- NO_HUD
-- HUD1 

HUD = "Show" -- Shows HUD
DEBUG = true
Lock = true
--DrawColor = Color.new(0,0,0)
ColorName = "Red"
ColorPage = 1
-- Max is 1

Date = {
	Day = 31,
	Month = 1,
	Year = 2020,
	
	Hour = 12,
	Minute = 25,
	Second = 30,
	Millisecond = 1000,
}
--[[
function RefreshDate()
	Date.Day = System.getDate(3)
	Date.Month = System.getDate(2)
	Date.Year = System.getDate(1)
	
	Date.Hour = System.getTime(1)
	Date.Minute = System.getTime(2)
	Date.Second = System.getTime(3)
	Date.Millisecond = System.getTime(4)
end
--]]

function GtR(angle) --grad to rad
	return angle*3.1415926535/180;
end

function TestDraw(X, Y, Color, BrushSize)
	for i = 0, 720 do
		Alpha_SetPixel(X + BrushSize * math.cos(GtR(i)), Y + BrushSize * math.sin(GtR(i)), Color);
	end
end

-- 0.5
-- 0.1

-- 1.0 - Максимальное число, больше - потери, меньше - Медленнее

function TestDraw2(X, Y, Color, BrushSize)
	for i = 0, 360, 0.5 do
		for i2 = 0, BrushSize, 1.0 do -- чем меньше шаг - тем качественнее, но тем медленнее...
			Alpha_SetPixel(X + i2 * math.cos(GtR(i)), Y + i2 * math.sin(GtR(i)), Color)
		end
	end
end

AlX = 0
AlY = 0

function AlignType(Type, Ty, FuAlign, FuRadius)
	if Type == 1 then
		if Ty == "Square" then
			if FuAlign == "Center" then
				AlX = FuRadius / 2 * (-1)
				AlY = FuRadius / 2 * (-1)
			elseif FuAlign == "Right-Down" then
				AlX = FuRadius / 2
				AlY = FuRadius / 2
			elseif FuAlign == "Left-Up" then
				AlX = 0 - (FuRadius / 2) * 2
				AlY = 0 - (FuRadius / 2) * 2
			end
		elseif Ty == "Circle" then
			if FuAlign == "Center" then
				AlX = 0 - (FuRadius / 2) * 2
				AlY = 0 - (FuRadius / 2) * 2
			elseif FuAlign == "Right-Down" then
				AlX = FuRadius / 2
				AlY = FuRadius / 2
			elseif FuAlign == "Left-Up" then
				AlX = 0 - (FuRadius / 2) * 4
				AlY = 0 - (FuRadius / 2) * 4
			end
		end
		
	elseif Type == 2 then
		
	end
end

function Draw(Type, X, Y, Form, Color, BrushSize, Align)
	
	if Form == "Square" then
		for i = 1, 50 do
			if BrushSize == i then
				AlignType(1, "Square", Align, i)
				
				
				if Type == "screen" then
					screen:fillRect(X + AlX, Y + AlY, i, i, Color)
				elseif Type == "Alpha1" then
					Alpha:fillRect(X + AlX, Y + AlY, i, i, Color)
				end
			end
		end
		
	elseif Form == "Circle" then
		if BrushSize == 1 then
			Radius = 2
			AlignType(1, "Circle", Align, Radius)
			
			if Type == "screen" then
				screen:drawLine(X + 2 + AlX, Y + 1 + AlY, X + 2 + AlX, Y + 3 + AlY, Color)
				screen:drawLine(X + 1 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 2 + AlY, Color)
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 2 + AlX, Y + 1 + AlY, X + 2 + AlX, Y + 3 + AlY, Color)
				Alpha:drawLine(X + 1 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 2 + AlY, Color)
			end
			
			-- -0-
			-- 000
			-- -0-
			
		elseif BrushSize == 2 then
			Radius = 3
			AlignType(1, "Circle", Align, Radius)
			
			if Type == "screen" then
				screen:fillRect(X + 2 + AlX, Y + 1 + AlY, 3, 5, Color)
				screen:drawLine(X + 1 + AlX, Y + 2 + AlY, X + 1 + AlX, Y + 4 + AlY, Color)
				screen:drawLine(X + 5 + AlX, Y + 2 + AlY, X + 5 + AlX, Y + 4 + AlY, Color)
			elseif Type == "Alpha1" then
				Alpha:fillRect(X + 2 + AlX, Y + 1 + AlY,3, 5, Color)
				Alpha:drawLine(X + 1 + AlX, Y + 2 + AlY, X + 1 + AlX, Y + 4 + AlY, Color)
				Alpha:drawLine(X + 5 + AlX, Y + 2 + AlY, X + 5 + AlX, Y + 4 + AlY, Color)
			end
			
		
			
			-- -000-
			-- 00000
			-- 00100
			-- 00000
			-- -000-
			
		elseif BrushSize == 3 then
			Radius = 4
			AlignType(1, "Circle", Align, Radius)
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 3 + AlY, X + 1 + AlX, Y + 5 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 2 + AlY, X + 2 + AlX, Y + 6 + AlY, Color)
				
				screen:fillRect(X + 3 + AlX, Y + 1 + AlY, 3, 7, Color)
				
				screen:drawLine(X + 6 + AlX, Y + 2 + AlY, X + 6 + AlX, Y + 6 + AlY, Color)
				screen:drawLine(X + 7 + AlX, Y + 3 + AlY, X + 7 + AlX, Y + 5 + AlY, Color)
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 3 + AlY, X + 1 + AlX, Y + 5 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 2 + AlY, X + 2 + AlX, Y + 6 + AlY, Color)
				
				Alpha:fillRect(X + 3 + AlX, Y + 1 + AlY, 3, 7, Color)
				
				Alpha:drawLine(X + 6 + AlX, Y + 2 + AlY, X + 6 + AlX, Y + 6 + AlY, Color)
				Alpha:drawLine(X + 7 + AlX, Y + 3 + AlY, X + 7 + AlX, Y + 5 + AlY, Color)
			end
			
			-- --000--
			-- -00000-
			-- 0000000
			-- 0001000
			-- 0000000
			-- -00000-
			-- --000--
			
		elseif BrushSize == 4 then
			Radius = 5
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 4 + AlY, X + 1 + AlX, Y + 6 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 3 + AlY, X + 2 + AlX, Y + 7 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 8 + AlY, Color)
				
				screen:fillRect(X + 4 + AlX, Y + 1 + AlY, 3, 9, Color)
				
				screen:drawLine(X + 7 + AlX, Y + 2 + AlY, X + 7 + AlX, Y + 8 + AlY, Color)
				screen:drawLine(X + 8 + AlX, Y + 3 + AlY, X + 8 + AlX, Y + 7 + AlY, Color)
				screen:drawLine(X + 9 + AlX, Y + 4 + AlY, X + 9 + AlX, Y + 6 + AlY, Color)
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 4 + AlY, X + 1 + AlX, Y + 6 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 3 + AlY, X + 2 + AlX, Y + 7 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 8 + AlY, Color)
				
				Alpha:fillRect(X + 4 + AlX, Y + 1 + AlY, 3, 9, Color)
				
				Alpha:drawLine(X + 7 + AlX, Y + 2 + AlY, X + 7 + AlX, Y + 8 + AlY, Color)
				Alpha:drawLine(X + 8 + AlX, Y + 3 + AlY, X + 8 + AlX, Y + 7 + AlY, Color)
				Alpha:drawLine(X + 9 + AlX, Y + 4 + AlY, X + 9 + AlX, Y + 6 + AlY, Color)
			end
			-- 9x9
			
			-- ---000---
			-- --00000--
			-- -0000000-
			-- 000000000
			-- 000010000
			-- 000000000
			-- -0000000-
			-- --00000--
			-- ---000---
		elseif BrushSize == 5 then
			Radius = 6
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 4 + AlY, X + 1 + AlX, Y + 8 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 3 + AlY, X + 2 + AlX, Y + 9 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 10 + AlY, Color)
				
				screen:fillRect(X + 4 + AlX, Y + 1 + AlY, 5, 11, Color)
				
				screen:drawLine(X + 9 + AlX, Y + 2 + AlY, X + 9 + AlX, Y + 10 + AlY, Color)
				screen:drawLine(X + 10 + AlX, Y + 3 + AlY, X + 10 + AlX, Y + 9 + AlY, Color)
				screen:drawLine(X + 11 + AlX, Y + 4 + AlY, X + 11 + AlX, Y + 8 + AlY, Color)
				
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 4 + AlY, X + 1 + AlX, Y + 8 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 3 + AlY, X + 2 + AlX, Y + 9 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 2 + AlY, X + 3 + AlX, Y + 10 + AlY, Color)
				
				Alpha:fillRect(X + 4 + AlX, Y + 1 + AlY, 5, 11, Color)
				
				Alpha:drawLine(X + 9 + AlX, Y + 2 + AlY, X + 9 + AlX, Y + 10 + AlY, Color)
				Alpha:drawLine(X + 10 + AlX, Y + 3 + AlY, X + 10 + AlX, Y + 9 + AlY, Color)
				Alpha:drawLine(X + 11 + AlX, Y + 4 + AlY, X + 11 + AlX, Y + 8 + AlY, Color)
			end
			
			-- 11x11
			
			-- ---00000---
			-- --0000000--
			-- -000000000-
			-- 00000000000
			-- 00000000000
			-- 00000100000
			-- 00000000000
			-- 00000000000
			-- -000000000-
			-- --0000000--
			-- ---00000---
			
		elseif BrushSize == 6 then
			Radius = 7
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 6 + AlY, X + 1 + AlX, Y + 8 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 4 + AlY, X + 2 + AlX, Y + 10 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 3 + AlY, X + 3 + AlX, Y + 11 + AlY, Color)
				
				screen:fillRect(X + 4 + AlX, Y + 2 + AlY, 2, 11, Color)
				screen:fillRect(X + 6 + AlX, Y + 1 + AlY, 3, 13, Color)
				screen:fillRect(X + 9 + AlX, Y + 2 + AlY, 2, 11, Color)
				
				screen:drawLine(X + 11 + AlX, Y + 3 + AlY, X + 11 + AlX, Y + 11 + AlY, Color)
				screen:drawLine(X + 12 + AlX, Y + 4 + AlY, X + 12 + AlX, Y + 10 + AlY, Color)
				screen:drawLine(X + 13 + AlX, Y + 6 + AlY, X + 13 + AlX, Y + 8 + AlY, Color)
				
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 6 + AlY, X + 1 + AlX, Y + 8 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 4 + AlY, X + 2 + AlX, Y + 10 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 3 + AlY, X + 3 + AlX, Y + 11 + AlY, Color)
				
				Alpha:fillRect(X + 4 + AlX, Y + 2 + AlY, 2, 11, Color)
				Alpha:fillRect(X + 6 + AlX, Y + 1 + AlY, 3, 13, Color)
				Alpha:fillRect(X + 9 + AlX, Y + 2 + AlY, 2, 11, Color)
				
				Alpha:drawLine(X + 11 + AlX, Y + 3 + AlY, X + 11 + AlX, Y + 11 + AlY, Color)
				Alpha:drawLine(X + 12 + AlX, Y + 4 + AlY, X + 12 + AlX, Y + 10 + AlY, Color)
				Alpha:drawLine(X + 13 + AlX, Y + 6 + AlY, X + 13 + AlX, Y + 8 + AlY, Color)
			end
			
			-- 13x13
			
			-- Sorry, there's no pixel art anymore :c
			
		
		
		elseif BrushSize == 7 then
			Radius = 8
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 6 + AlY, X + 1 + AlX, Y + 10 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 4 + AlY, X + 2 + AlX, Y + 12 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 3 + AlY, X + 3 + AlX, Y + 13 + AlY, Color)
				
				screen:fillRect(X + 4 + AlX, Y + 2 + AlY, 2, 13, Color)
				screen:fillRect(X + 6 + AlX, Y + 1 + AlY, 5, 15, Color)
				screen:fillRect(X + 11 + AlX, Y + 2 + AlY, 2, 13, Color)
				
				screen:drawLine(X + 13 + AlX, Y + 3 + AlY, X + 13 + AlX, Y + 13 + AlY, Color)
				screen:drawLine(X + 14 + AlX, Y + 4 + AlY, X + 14 + AlX, Y + 12 + AlY, Color)
				screen:drawLine(X + 15 + AlX, Y + 6 + AlY, X + 15 + AlX, Y + 10 + AlY, Color)
				
			
				
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 6 + AlY, X + 1 + AlX, Y + 10 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 4 + AlY, X + 2 + AlX, Y + 12 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 3 + AlY, X + 3 + AlX, Y + 13 + AlY, Color)
				
				Alpha:fillRect(X + 4 + AlX, Y + 2 + AlY, 2, 13, Color)
				Alpha:fillRect(X + 6 + AlX, Y + 1 + AlY, 5, 15, Color)
				Alpha:fillRect(X + 11 + AlX, Y + 2 + AlY, 2, 13, Color)
				
				Alpha:drawLine(X + 13 + AlX, Y + 3 + AlY, X + 13 + AlX, Y + 13 + AlY, Color)
				Alpha:drawLine(X + 14 + AlX, Y + 4 + AlY, X + 14 + AlX, Y + 12 + AlY, Color)
				Alpha:drawLine(X + 15 + AlX, Y + 6 + AlY, X + 15 + AlX, Y + 10 + AlY, Color)
			end
			
			-- 15x15
			
		elseif BrushSize == 8 then
			Radius = 8
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 8 + AlY, X + 1 + AlX, Y + 10 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 6 + AlY, X + 2 + AlX, Y + 12 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 4 + AlY, X + 3 + AlX, Y + 14 + AlY, Color)
				
				screen:fillRect(X + 4 + AlX, Y + 3 + AlY, 2, 13, Color)
				screen:fillRect(X + 6 + AlX, Y + 2 + AlY, 2, 15, Color)
				
				screen:fillRect(X + 8 + AlX, Y + 1 + AlY, 3, 17, Color)
				
				screen:fillRect(X + 11 + AlX, Y + 2 + AlY, 2, 15, Color)
				screen:fillRect(X + 13 + AlX, Y + 3 + AlY, 2, 13, Color)
				
				screen:drawLine(X + 15 + AlX, Y + 4 + AlY, X + 15 + AlX, Y + 14 + AlY, Color)
				screen:drawLine(X + 16 + AlX, Y + 6 + AlY, X + 16 + AlX, Y + 12 + AlY, Color)
				screen:drawLine(X + 17 + AlX, Y + 8 + AlY, X + 17 + AlX, Y + 10 + AlY, Color)
				
				-- 1, 8, 1, 10
				-- 2, 6, 2, 12
				-- 3, 4, 3, 14
				
				-- 4, 3, 2, 13
				-- 6, 2, 2, 15
				
				-- 8, 1, 3, 17
				
				-- 11, 2, 2, 15
				-- 13, 3, 2, 13
				
				-- 15, 4, 15, 14
				-- 16, 6, 16, 12
				-- 17, 8, 17, 10
			
				
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 8 + AlY, X + 1 + AlX, Y + 10 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 6 + AlY, X + 2 + AlX, Y + 12 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 4 + AlY, X + 3 + AlX, Y + 14 + AlY, Color)
				
				Alpha:fillRect(X + 4 + AlX, Y + 3 + AlY, 2, 13, Color)
				Alpha:fillRect(X + 6 + AlX, Y + 2 + AlY, 2, 15, Color)
				
				Alpha:fillRect(X + 8 + AlX, Y + 1 + AlY, 3, 17, Color)
				
				Alpha:fillRect(X + 11 + AlX, Y + 2 + AlY, 2, 15, Color)
				Alpha:fillRect(X + 13 + AlX, Y + 3 + AlY, 2, 13, Color)
				
				Alpha:drawLine(X + 15 + AlX, Y + 4 + AlY, X + 15 + AlX, Y + 14 + AlY, Color)
				Alpha:drawLine(X + 16 + AlX, Y + 6 + AlY, X + 16 + AlX, Y + 12 + AlY, Color)
				Alpha:drawLine(X + 17 + AlX, Y + 8 + AlY, X + 17 + AlX, Y + 10 + AlY, Color)
			end
			
			-- 17x17
			
		elseif BrushSize == 9 then
			Radius = 8
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 9 + AlY, X + 1 + AlX, Y + 11 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 7 + AlY, X + 2 + AlX, Y + 13 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 5 + AlY, X + 3 + AlX, Y + 15 + AlY, Color)
				screen:drawLine(X + 4 + AlX, Y + 4 + AlY, X + 4 + AlX, Y + 16 + AlY, Color)
				
				screen:fillRect(X + 5 + AlX, Y + 3 + AlY, 2, 15, Color)
				screen:fillRect(X + 7 + AlX, Y + 2 + AlY, 2, 17, Color)
				
				screen:fillRect(X + 9 + AlX, Y + 1 + AlY, 3, 19, Color)
				
				screen:fillRect(X + 12 + AlX, Y + 2 + AlY, 2, 17, Color)
				screen:fillRect(X + 14 + AlX, Y + 3 + AlY, 2, 15, Color)
				
				screen:drawLine(X + 16 + AlX, Y + 4 + AlY, X + 16 + AlX, Y + 16 + AlY, Color)
				screen:drawLine(X + 17 + AlX, Y + 5 + AlY, X + 17 + AlX, Y + 15 + AlY, Color)
				screen:drawLine(X + 18 + AlX, Y + 7 + AlY, X + 18 + AlX, Y + 13 + AlY, Color)
				screen:drawLine(X + 19 + AlX, Y + 9 + AlY, X + 19 + AlX, Y + 11 + AlY, Color)
				
				
				-- 1, 9, 1, 11
				-- 2, 7, 2, 13
				-- 3, 5, 3, 15
				-- 4, 4, 4, 16 -
				
				-- 5, 3, 2, 16
				-- 7, 2, 2, 17
				
				-- 9, 1, 3, 18
				
				-- 12, 2, 2, 17
				-- 14, 2, 2, 16
				
				-- 16, 4, 16, 16 -
				-- 17, 5, 17, 15
				-- 18, 7, 18, 13
				-- 19, 9, 19, 11
			
				
			elseif Type == "Alpha1" then
				Alpha:drawLine(X + 1 + AlX, Y + 9 + AlY, X + 1 + AlX, Y + 11 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 7 + AlY, X + 2 + AlX, Y + 13 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 5 + AlY, X + 3 + AlX, Y + 15 + AlY, Color)
				Alpha:drawLine(X + 4 + AlX, Y + 4 + AlY, X + 4 + AlX, Y + 16 + AlY, Color)
				
				Alpha:fillRect(X + 5 + AlX, Y + 3 + AlY, 2, 15, Color)
				Alpha:fillRect(X + 7 + AlX, Y + 2 + AlY, 2, 17, Color)
				
				Alpha:fillRect(X + 9 + AlX, Y + 1 + AlY, 3, 19, Color)
				
				Alpha:fillRect(X + 12 + AlX, Y + 2 + AlY, 2, 17, Color)
				Alpha:fillRect(X + 14 + AlX, Y + 3 + AlY, 2, 15, Color)
				
				Alpha:drawLine(X + 16 + AlX, Y + 4 + AlY, X + 16 + AlX, Y + 16 + AlY, Color)
				Alpha:drawLine(X + 17 + AlX, Y + 5 + AlY, X + 17 + AlX, Y + 15 + AlY, Color)
				Alpha:drawLine(X + 18 + AlX, Y + 7 + AlY, X + 18 + AlX, Y + 13 + AlY, Color)
				Alpha:drawLine(X + 19 + AlX, Y + 9 + AlY, X + 19 + AlX, Y + 11 + AlY, Color)
			end
			
			-- 19x19
			
		elseif BrushSize == 10 then
			Radius = 8
			AlignType(1, "Circle", Align, Radius)
			
			
			
			if Type == "screen" then
				screen:drawLine(X + 1 + AlX, Y + 9 + AlY, X + 1 + AlX, Y + 13 + AlY, Color)
				screen:drawLine(X + 2 + AlX, Y + 7 + AlY, X + 2 + AlX, Y + 15 + AlY, Color)
				screen:drawLine(X + 3 + AlX, Y + 5 + AlY, X + 3 + AlX, Y + 17 + AlY, Color)
				screen:drawLine(X + 4 + AlX, Y + 4 + AlY, X + 4 + AlX, Y + 18 + AlY, Color)
				
				screen:fillRect(X + 5 + AlX, Y + 3 + AlY, 2, 17, Color)
				screen:fillRect(X + 7 + AlX, Y + 2 + AlY, 2, 19, Color)
				
				screen:fillRect(X + 9 + AlX, Y + 1 + AlY, 5, 21, Color)
				
				screen:fillRect(X + 14 + AlX, Y + 2 + AlY, 2, 19, Color)
				screen:fillRect(X + 16 + AlX, Y + 3 + AlY, 2, 17, Color)
				
				screen:drawLine(X + 18 + AlX, Y + 4 + AlY, X + 18 + AlX, Y + 18 + AlY, Color)
				screen:drawLine(X + 19 + AlX, Y + 5 + AlY, X + 19 + AlX, Y + 17 + AlY, Color)
				screen:drawLine(X + 20 + AlX, Y + 7 + AlY, X + 20 + AlX, Y + 15 + AlY, Color)
				screen:drawLine(X + 21 + AlX, Y + 9 + AlY, X + 21 + AlX, Y + 13 + AlY, Color)
				
				-- 1, 9, 1, 13
				-- 2, 7, 2, 15
				-- 3, 5, 3, 17
				-- 4, 4, 4, 18 -
				
				-- 5, 3, 2, 17
				-- 7, 2, 2, 19
				
				-- 9, 1, 5, 21
				
				-- 14, 2, 2, 19
				-- 16, 3, 2, 17
				
				-- 18, 4, 18, 18
				-- 19, 5, 19, 17
				-- 20, 7, 20, 15
				-- 21, 9, 21, 13 -
			
				
			elseif Type == "Alpha1" then
				
				Alpha:drawLine(X + 1 + AlX, Y + 9 + AlY, X + 1 + AlX, Y + 13 + AlY, Color)
				Alpha:drawLine(X + 2 + AlX, Y + 7 + AlY, X + 2 + AlX, Y + 15 + AlY, Color)
				Alpha:drawLine(X + 3 + AlX, Y + 5 + AlY, X + 3 + AlX, Y + 17 + AlY, Color)
				Alpha:drawLine(X + 4 + AlX, Y + 4 + AlY, X + 4 + AlX, Y + 18 + AlY, Color)
				
				Alpha:fillRect(X + 5 + AlX, Y + 3 + AlY, 2, 17, Color)
				Alpha:fillRect(X + 7 + AlX, Y + 2 + AlY, 2, 19, Color)
				
				Alpha:fillRect(X + 9 + AlX, Y + 1 + AlY, 5, 21, Color)
				
				Alpha:fillRect(X + 14 + AlX, Y + 2 + AlY, 2, 19, Color)
				Alpha:fillRect(X + 16 + AlX, Y + 3 + AlY, 2, 17, Color)
				
				Alpha:drawLine(X + 18 + AlX, Y + 4 + AlY, X + 18 + AlX, Y + 18 + AlY, Color)
				Alpha:drawLine(X + 19 + AlX, Y + 5 + AlY, X + 19 + AlX, Y + 17 + AlY, Color)
				Alpha:drawLine(X + 20 + AlX, Y + 7 + AlY, X + 20 + AlX, Y + 15 + AlY, Color)
				Alpha:drawLine(X + 21 + AlX, Y + 9 + AlY, X + 21 + AlX, Y + 13 + AlY, Color)
				
				-- 21x21
				
			end
			
		end
	elseif Form == "Everything" then
		Alpha:fillRect(0, 0, 480, 272, Color)
	end
end

function DrawRY(What, X, Y)
	Col = Black
	ModX = 0
	ModY = 0
	if What == "R" then
		for i = 1, 2 do
			screen:drawLine(X + 3 + ModX, Y + 1 + ModY, X + 3 + ModX, Y + 8 + ModY, Col)
			screen:drawLine(X + 4 + ModX, Y + 1 + ModY, X + 6 + ModX, Y + 8 + ModY, Col)
			screen:drawLine(X + 6 + ModX, Y + 2 + ModY, X + 6 + ModX, Y + 5 + ModY, Col)
			screen_SetPixel(X + 4 + ModX, Y + 5 + ModY, Col)
			screen_SetPixel(X + 5 + ModX, Y + 5 + ModY, Col)
			screen_SetPixel(X + 4 + ModX, Y + 6 + ModY, Col)
			screen_SetPixel(X + 5 + ModX, Y + 6 + ModY, Col)
			
			screen_SetPixel(X + 5 + ModX, Y + 7 + ModY, Col)
			screen_SetPixel(X + 6 + ModX, Y + 7 + ModY, Col)
			screen_SetPixel(X + 6 + ModX, Y + 8 + ModY, Col)
			Col = White
			ModX = 1
			ModY = -1
		end
	elseif What == "L" then
		screen:drawLine(X + 3, Y + 1, X + 3, Y + 7, Black)
		screen:drawLine(X + 4, Y + 7, X + 7, Y + 7, Black)
		
		screen:drawLine(X + 2, Y + 2, X + 2, Y + 8, White)
		screen:drawLine(X + 3, Y + 8, X + 6, Y + 8, White)
	end
	
end

function DrawThicknessPanel(Where)
	
	xCr = 0
	yCr = 0
	
	if Timer.PanelThickness ~= 0 then
		
		if Where == "Paint" then
			screen:blit(378, 0, Sprite.ThicknessNon)
			xCr = 378
			yCr = 80
		elseif Where == "HUD" then
			screen:blit(319, 0, Sprite.PanelThickness)
			xCr = 319
			yCr = 95
		end
		
		if Cursor.Form == "Square" then
			Draw("screen", xCr + 8, yCr + 8, "Square", Black, Cursor.Thickness, "Right-Down")
		elseif Cursor.Form == "Circle" then
			Draw("screen", xCr + 10, yCr + 10, "Circle", Black, Cursor.Thickness, "Right-Down")
		end
		
		screen:fontPrint(Arial,xCr + 30, yCr + 90,"Size: "..Cursor.Thickness,Black)
		
	end
end

function DrawSpeedPanel(Where, x, y)
	if Timer.PanelSpeed ~= 0 then
		
		if Where == "Paint" then
			screen:blit(x, y, Sprite.SpeedNon)
			X = 31
		elseif Where == "HUD" then
			screen:blit(x, y, Sprite.PanelSpeed)
			X = 89
		end
		
		if Cursor.Speed == 1 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
		elseif Cursor.Speed == 2 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
		elseif Cursor.Speed == 3 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
		elseif Cursor.Speed == 4 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
			screen:blit(X, 145, Sprite.SpeedIcons.Slow)
		elseif Cursor.Speed == 5 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
			screen:blit(X, 145, Sprite.SpeedIcons.Slow)
			screen:blit(X, 133, Sprite.SpeedIcons.Slow)
		elseif Cursor.Speed == 6 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
			screen:blit(X, 145, Sprite.SpeedIcons.Slow)
			screen:blit(X, 133, Sprite.SpeedIcons.Slow)
			screen:blit(X, 121, Sprite.SpeedIcons.SuperSlow)
		elseif Cursor.Speed == 7 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
			screen:blit(X, 145, Sprite.SpeedIcons.Slow)
			screen:blit(X, 133, Sprite.SpeedIcons.Slow)
			screen:blit(X, 121, Sprite.SpeedIcons.SuperSlow)
			screen:blit(X, 109, Sprite.SpeedIcons.SuperSlow)
		elseif Cursor.Speed == 8 then
			screen:blit(X, 181, Sprite.SpeedIcons.Fast)
			screen:blit(X, 169, Sprite.SpeedIcons.Fast)
			screen:blit(X, 157, Sprite.SpeedIcons.Normal)
			screen:blit(X, 145, Sprite.SpeedIcons.Slow)
			screen:blit(X, 133, Sprite.SpeedIcons.Slow)
			screen:blit(X, 121, Sprite.SpeedIcons.SuperSlow)
			screen:blit(X, 109, Sprite.SpeedIcons.SuperSlow)
			screen:blit(X, 97,  Sprite.SpeedIcons.SuperSlow)
		end
		
	end
end

Sel = {
	RX = 29,
	RY = 61,
	
	LX = 3,
	LY = 61,
}

if Cursor.StickSwap == true then
	StickMod = -1
elseif Cursor.StickSwap == false then
	StickMod = 1
end


ColorsPage = Image.createEmpty(80, 272)
ColorsPage:fillRect(3,61,10,10,Palette.Color1)
ColorsPage:fillRect(16,61,10,10,Palette.Color2)
ColorsPage:fillRect(29,61,10,10,Palette.Color3)
ColorsPage:fillRect(42,61,10,10,Palette.Color4)

ColorsPage:fillRect(3,73,10,10,Palette.Color5)
ColorsPage:fillRect(16,73,10,10,Palette.Color6)
ColorsPage:fillRect(29,73,10,10,Palette.Color7)
ColorsPage:fillRect(42,73,10,10,Palette.Color8)

ColorsPage:fillRect(3,85,10,10,Palette.Color9)
ColorsPage:fillRect(16,85,10,10,Palette.Color10)
ColorsPage:fillRect(29,85,10,10,Palette.Color11)
ColorsPage:fillRect(42,85,10,10,Palette.Color12)

ColorsPage:fillRect(3,97,10,10,Palette.Color13)
ColorsPage:fillRect(16,97,10,10,Palette.Color14)
ColorsPage:fillRect(29,97,10,10,Palette.Color15)
ColorsPage:fillRect(42,97,10,10,Palette.Color16)

ColorsPage:fillRect(3,109,10,10,Palette.Color17)
ColorsPage:fillRect(16,109,10,10,Palette.Color18)
ColorsPage:fillRect(29,109,10,10,Palette.Color19)
ColorsPage:fillRect(42,109,10,10,Palette.Color20)

ColorsPage:fillRect(3,121,10,10,Palette.Color21)
ColorsPage:fillRect(16,121,10,10,Palette.Color22)
ColorsPage:fillRect(29,121,10,10,Palette.Color23)
ColorsPage:fillRect(42,121,10,10,Palette.Color24)

ColorsPage:fillRect(3,133,10,10,Palette.Color25)
ColorsPage:fillRect(16,133,10,10,Palette.Color26)
ColorsPage:fillRect(29,133,10,10,Palette.Color27)
ColorsPage:fillRect(42,133,10,10,Palette.Color28)

ColorsPage:fillRect(3,145,10,10,Palette.Color29)
ColorsPage:fillRect(16,145,10,10,Palette.Color30)
ColorsPage:fillRect(29,145,10,10,Palette.Color31)
ColorsPage:fillRect(42,145,10,10,Palette.Color32)

ColorsPage:fillRect(3,157,10,10,Palette.Color33)
ColorsPage:fillRect(16,157,10,10,Palette.Color34)
ColorsPage:fillRect(29,157,10,10,Palette.Color35)
ColorsPage:fillRect(42,157,10,10,Palette.Color36)

ColorsPage:fillRect(3,169,10,10,Palette.Color37)
ColorsPage:fillRect(16,169,10,10,Palette.Color38)
ColorsPage:fillRect(29,169,10,10,Palette.Color39)
ColorsPage:fillRect(42,169,10,10,Palette.Color40)

ColorsPage:fillRect(3,181,10,10,Palette.Color41)
ColorsPage:fillRect(16,181,10,10,Palette.Color42)
ColorsPage:fillRect(29,181,10,10,Palette.Color43)
ColorsPage:fillRect(42,181,10,10,Palette.Color44)

ColorsPage:fillRect(3,193,10,10,Palette.Color45)
ColorsPage:fillRect(16,193,10,10,Palette.Color46)
ColorsPage:fillRect(29,193,10,10,Palette.Color47)
ColorsPage:fillRect(42,193,10,10,Palette.Color48)

EveryPanel = Image.createEmpty(480, 272)
EveryPanel:blit(0, 0, Sprite.PanelTool)
EveryPanel:blit(0, 0, Sprite.PanelColor)
EveryPanel:blit(415, 0, Sprite.PanelParams)

Sprite.PanelTool = nil
Sprite.PanelColor = nil
Sprite.PanelParams = nil

function CheckSpeed()
	if Cursor.Speed == 1 then -- Fast
		Sensity = 15 * StickMod
	elseif Cursor.Speed == 2 then -- Fast
		Sensity = 25 * StickMod
	elseif Cursor.Speed == 3 then -- Normal
		Sensity = 110 * StickMod
	elseif Cursor.Speed == 4 then -- Slow
		Sensity = 200 * StickMod
	elseif Cursor.Speed == 5 then -- Slow
		Sensity = 250 * StickMod
	elseif Cursor.Speed == 6 then -- Super Slow
		Sensity = 400 * StickMod
	elseif Cursor.Speed == 7 then -- Super Slow
		Sensity = 700 * StickMod
	elseif Cursor.Speed == 8 then -- Super Slow
		Sensity = 900 * StickMod
	end
end

CheckSpeed()

-------------------------------------------------------
while true do
	pad = Controls.read()
	
	screen:clear(BGColor)
	screen:blit(0, 0, Alpha)
	
	-- Applying sensetivity here
	-- By Cursor's Speed we are changing Sensitivity
	
	
	--ANALOG-X
	dx = pad:analogX()
	if math.abs(dx) > 32 then
		Cursor.X = Cursor.X + dx / Sensity
	end
	
	--ANALOG-Y
	dy = pad:analogY()
	if math.abs(dy) > 32 then
		Cursor.Y = Cursor.Y + dy / Sensity
	end
	
	-- HUD Opening
	if pad:triangle() then
		if pressed.triangle == false then
			pressed.triangle = true
			if State == "HUD" then
				State = "Paint"
			elseif State == "Paint" then
				State = "HUD"
			end
		end
	else
		pressed.triangle = false
	end
	
		if pad:right() then
			--screen:fontPrint(Arial,340,10,"Thickness: "..Cursor.Thickness,Black)
			Timer.PanelThickness = 20
			if pressed.right == false then
				pressed.right = true
				Cursor.Thickness = Cursor.Thickness + 1
				if Cursor.Thickness > 50 then Cursor.Thickness = 1 end
			end
		else
			pressed.right = false
		end
		
		if pad:left() then
			--screen:fontPrint(Arial,340,10,"Thickness: "..Cursor.Thickness,Black)
			Timer.PanelThickness = 20
			if pressed.left == false then
				pressed.left = true
				Cursor.Thickness = Cursor.Thickness - 1
				if Cursor.Thickness < 1 then Cursor.Thickness = 50 end
			end
		else
			pressed.left = false
		end
		
		
		-- Speed modificators
		if pad:down() then
			if pressed.down == false then
				pressed.down = true
				Cursor.Speed = Cursor.Speed - 1
				if Cursor.Speed < 1 then Cursor.Speed = 1 end
				CheckSpeed()
			end
		else
			pressed.down = false
		end
		
		if pad:up() then

			if pressed.up == false then
				pressed.up = true
				Cursor.Speed = Cursor.Speed + 1
				if Cursor.Speed > 8 then Cursor.Speed = 8 end
				CheckSpeed()
			end
		else
			pressed.up = false
		end
	
	
	Timer.PanelSpeed = Timer.PanelSpeed - 1
	if Timer.PanelSpeed < 0 then Timer.PanelSpeed = 0 end
	
	Timer.PanelThickness = Timer.PanelThickness - 1
	if Timer.PanelThickness < 0 then Timer.PanelThickness = 0 end
	
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	
	if State == "Paint" then
		
		
		if IsSaving == true then
			TakeScreenshot()
		else
			IsSaving = false
		end
		
		if Cursor.Tool == "Pencil" then		
			if pad:l() then
				Draw("Alpha1", Cursor.X, Cursor.Y, Cursor.Form, AColor, Cursor.Thickness, ToolPackinfo.System)
				LastColor = AColor
			elseif pad:r() then
				Draw("Alpha1", Cursor.X, Cursor.Y, Cursor.Form, BColor, Cursor.Thickness, ToolPackinfo.System)
				LastColor = BColor
			end
			
			
		elseif  Cursor.Tool == "Eraser" then
			if pad:l() or pad:r() then
				Draw("Alpha1", Cursor.X, Cursor.Y, "Circle", White, 10, ToolPackinfo.System)
			end
			
			
		elseif Cursor.Tool == "Fill" then
			if pad:l() then
				Draw("Alpha1", nil, nil, "Everything", AColor, nil, nil)
			elseif pad:r() then
				Draw("Alpha1", nil, nil, "Everything", BColor, nil, nil)
			end
			
			
		elseif Cursor.Tool == "Square" then
			if pad:l() then
				Cursor.Fill.x0 = Cursor.X
				Cursor.Fill.y0 = Cursor.Y
			end
			if pad:r() then
				Cursor.Fill.x1 = Cursor.X
				Cursor.Fill.y1 = Cursor.Y
				Cursor.Fill.w = Cursor.X - Cursor.Fill.x0
				Cursor.Fill.h = Cursor.Y - Cursor.Fill.y0
			end
			
			screen:fillRect(Cursor.Fill.x0, Cursor.Fill.y0, Cursor.Fill.w, Cursor.Fill.h, AColor)
			
			if pad:cross() then
				Alpha:fillRect(Cursor.Fill.x0, Cursor.Fill.y0, Cursor.Fill.w, Cursor.Fill.h, AColor)
			end
			
			if Editor.STPointForm == "Circle" then
				Draw("screen", Cursor.Fill.x0, Cursor.Fill.y0, "Circle", Black, 2, "Center")
				Draw("screen", Cursor.Fill.x0, Cursor.Fill.y0, "Circle", Blue, 1, "Center")
				
				Draw("screen", Cursor.Fill.x1, Cursor.Fill.y1, "Circle", Black, 2, "Center")
				Draw("screen", Cursor.Fill.x1, Cursor.Fill.y1, "Circle", Blue, 1, "Center")
			elseif Editor.STPointForm == "Square" then
				Draw("screen", Cursor.Fill.x0, Cursor.Fill.y0, "Square", Black, 4, "Center")
				Draw("screen", Cursor.Fill.x0, Cursor.Fill.y0, "Square", Blue, 3, "Center")
				
				Draw("screen", Cursor.Fill.x1, Cursor.Fill.y1, "Square", Black, 4, "Center")
				Draw("screen", Cursor.Fill.x1, Cursor.Fill.y1, "Square", Blue, 3, "Center")
			end
			
		end
		
		--[[
		if pad:square() then
			TestDraw(Cursor.X, Cursor.Y, AColor, Cursor.Thickness) -- Circle
		elseif pad:circle() then
			TestDraw2(Cursor.X, Cursor.Y, AColor, Cursor.Thickness) -- Filled Circle
		end
		--]]
		
		-- Speed Panel
		if pad:up() or pad:down() then
			Timer.PanelSpeed = 20
		end
		DrawSpeedPanel("Paint", 0, 0) -- Speed Panel Blitting
		
		-- Thickness Panel
		DrawThicknessPanel("Paint")
		
		if Cursor.Tool == "Pencil" then
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG.Pencil)
		elseif Cursor.Tool == "Eraser" then
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG.Eraser)
		elseif Cursor.Tool == "Fill" then
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG.FillTool)
		elseif Cursor.Tool == "Square" then
			screen:blit(Cursor.X, Cursor.Y, Cursor.IMG.SquareTool)
		end
		
		if Cursor.X > 480 then Cursor.X = 480 end
		if Cursor.X < 0 then Cursor.X = 0 end
		if Cursor.Y > 272-1 then Cursor.Y = 272-1 end
		if Cursor.Y < 0 then Cursor.Y = 0 end
		
	end -- Paint State
	
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	
	if State == "Menu" then
		
		
		-- In PL 0.3
		
	end
	
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	
	if State == "HUD" then
		
		--if HUD == "Show" then
			
			screen:blit(0, 0, EveryPanel)
			
			
			-- Speed Panel
			if pad:up() or pad:down() then
				Timer.PanelSpeed = 30
			end
			DrawSpeedPanel("HUD", 0, 0) -- Speed Panel Blitting
			
			--screen:fontPrint(Arial,340,10,"Bold: "..Bold,Black)
			
			-- Thickness Panel
			DrawThicknessPanel("HUD")
			
			
			-- Tool Panel
			screen:blit(155, 0, Sprite.Icon.Pencil) -- 16x16
			screen:blit(173, 0, Sprite.Icon.Eraser)
			screen:blit(269, 0, Sprite.Icon.FillTool)
			screen:blit(287, 0, Sprite.Icon.SquareTool)
			
			ToolSel = Image.createEmpty(16, 16)
			ToolCol = Color.new(255,255,0,100) -- Transparent Yellow (RGBA)
			ToolSel:fillRect(1,1,16,16,ToolCol)
			
			if Cursor.Tool == "Pencil" then
				screen:blit(155, 0, ToolSel)
			elseif Cursor.Tool == "Eraser" then
				screen:blit(173, 0, ToolSel)
			elseif Cursor.Tool == "Fill" then
				screen:blit(269, 0, ToolSel)
			elseif Cursor.Tool == "Square" then
				screen:blit(287, 0, ToolSel)
			end
			
			-- Changing a Tool
			if pad:cross() then
				if Cursor.X >= 155 and Cursor.X <= 155 + 16 and Cursor.Y >= 0 and Cursor.Y <= 16 then
					Cursor.Tool = "Pencil"
				elseif Cursor.X >= 173 and Cursor.X <= 173 + 16 and Cursor.Y >= 0 and Cursor.Y <= 16 then
					Cursor.Tool = "Eraser"
				elseif Cursor.X >= 269 and Cursor.X <= 269 + 16 and Cursor.Y >= 0 and Cursor.Y <= 16 then
					Cursor.Tool = "Fill"
				elseif Cursor.X >= 287 and Cursor.X <= 287 + 16 and Cursor.Y >= 0 and Cursor.Y <= 16 then
					Cursor.Tool = "Square"
				end
			end
			
			-- Params Panel
			
			if pad:cross() then
				if Cursor.X >= 434 and Cursor.X <= 434 + 20 and Cursor.Y >= 66 and Cursor.Y <= 66 + 20 then
					Cursor.Form = "Square"
				elseif Cursor.X >= 434 and Cursor.X <= 434 + 20 and Cursor.Y >= 90 and Cursor.Y <= 90 + 20 then
					if Cursor.Form == "Square" and Cursor.Thickness > 10 then Cursor.Thickness = 10 end
					Cursor.Form = "Circle"
				end
			end
			
			if Cursor.Form == "Square" then
				screen:fillRect(434,66-4,20,20,Blue)
			elseif Cursor.Form == "Circle" then
				screen:fillRect(434,90-4,20,20,Blue)
			end
			
			Draw("screen", 438-5, 66-5, "Square", Black, 10, "Right-Down")
			
			Draw("screen", 438-5, 90-5, "Circle", Black, 5, "Right-Down")
			
			-- Debugs...
			--[[
			screen:fontPrint(Arial,5,10,"Sel.RX = "..Sel.RX,Black)
			screen:fontPrint(Arial,5,22,"Sel.RY = "..Sel.RY,Black)
			
			screen:fontPrint(Arial,5,34,"Sel.LX = "..Sel.LX,Black)
			screen:fontPrint(Arial,5,46,"Sel.LY = "..Sel.LY,Black)
			
			--]]
			
			-- Color Palette Panel
			screen:fillRect(66,1,14,14,Black)
			screen:fillRect(67,2,12,12,AColor)
			
			screen:fillRect(401,1,14,14,Black)
			screen:fillRect(402,2,12,12,BColor)

			Arial:setPixelSizes(8,10) -- Small Font
			screen:fontPrint(Arial,3,213,ColorName,Black) -- Name of The Color
			Arial:setPixelSizes(11,11) -- Going Back to the Normal Font
			screen:fontPrint(Arial,18,226,ColorPage.."/1",Black) -- Page ID
			
			if ColorPage == 1 then
				
				screen:blit(0, 0, ColorsPage)
				
			end
			
			DrawRY("R", Sel.RX, Sel.RY)
			DrawRY("L", Sel.LX, Sel.LY)
			
			
			if ColorPage == 1 then
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 61 and Cursor.Y <= 61 + 10 then
					DetermineColor(1)
					ColorName = Palette.ColNa1
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 61 and Cursor.Y <= 61 + 10 then
					DetermineColor(2)
					ColorName = Palette.ColNa2
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 61 and Cursor.Y <= 61 + 10 then
					DetermineColor(3)
					ColorName = Palette.ColNa3
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 61 and Cursor.Y <= 61 + 10 then
					DetermineColor(4)
					ColorName = Palette.ColNa4
				end
				
					
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 73 and Cursor.Y <= 73 + 10 then
					DetermineColor(5)
					ColorName = Palette.ColNa5
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 73 and Cursor.Y <= 73 + 10 then
					DetermineColor(6)
					ColorName = Palette.ColNa6
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 73 and Cursor.Y <= 73 + 10 then
					DetermineColor(7)
					ColorName = Palette.ColNa7
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 73 and Cursor.Y <= 73 + 10 then
					DetermineColor(8)
					ColorName = Palette.ColNa8
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 85 and Cursor.Y <= 85 + 10 then
					DetermineColor(9)
					ColorName = Palette.ColNa9
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 85 and Cursor.Y <= 85 + 10 then
					DetermineColor(10)
					ColorName = Palette.ColNa10
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 85 and Cursor.Y <= 85 + 10 then
					DetermineColor(11)
					ColorName = Palette.ColNa11
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 85 and Cursor.Y <= 85 + 10 then
					DetermineColor(12)
					ColorName = Palette.ColNa12
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 97 and Cursor.Y <= 97 + 10 then
					DetermineColor(13)
					ColorName = Palette.ColNa13
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 97 and Cursor.Y <= 97 + 10 then
					DetermineColor(14)
					ColorName = Palette.ColNa14
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 97 and Cursor.Y <= 97 + 10 then
					DetermineColor(15)
					ColorName = Palette.ColNa15
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 97 and Cursor.Y <= 97 + 10 then
					DetermineColor(16)
					ColorName = Palette.ColNa16
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 109 and Cursor.Y <= 109 + 10 then
					DetermineColor(17)
					ColorName = Palette.ColNa17
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 109 and Cursor.Y <= 109 + 10 then
					DetermineColor(18)
					ColorName = Palette.ColNa18
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 109 and Cursor.Y <= 109 + 10 then
					DetermineColor(19)
					ColorName = Palette.ColNa19
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 109 and Cursor.Y <= 109 + 10 then
					DetermineColor(20)
					ColorName = Palette.ColNa20
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 121 and Cursor.Y <= 121 + 10 then
					DetermineColor(21)
					ColorName = Palette.ColNa21
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 121 and Cursor.Y <= 121 + 10 then
					DetermineColor(22)
					ColorName = Palette.ColNa22
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 121 and Cursor.Y <= 121 + 10 then
					DetermineColor(23)
					ColorName = Palette.ColNa23
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 121 and Cursor.Y <= 121 + 10 then
					DetermineColor(24)
					ColorName = Palette.ColNa24
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 133 and Cursor.Y <= 133 + 10 then
					DetermineColor(25)
					ColorName = Palette.ColNa25
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 133 and Cursor.Y <= 133 + 10 then
					DetermineColor(26)
					ColorName = Palette.ColNa26
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 133 and Cursor.Y <= 133 + 10 then
					DetermineColor(27)
					ColorName = Palette.ColNa27
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 133 and Cursor.Y <= 133 + 10 then
					DetermineColor(28)
					ColorName = Palette.ColNa28
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 145 and Cursor.Y <= 145 + 10 then
					DetermineColor(29)
					ColorName = Palette.ColNa29
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 145 and Cursor.Y <= 145 + 10 then
					DetermineColor(30)
					ColorName = Palette.ColNa30
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 145 and Cursor.Y <= 145 + 10 then
					DetermineColor(31)
					ColorName = Palette.ColNa31
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 145 and Cursor.Y <= 145 + 10 then
					DetermineColor(32)
					ColorName = Palette.ColNa32
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 157 and Cursor.Y <= 157 + 10 then
					DetermineColor(33)
					ColorName = Palette.ColNa33
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 157 and Cursor.Y <= 157 + 10 then
					DetermineColor(34)
					ColorName = Palette.ColNa34
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 157 and Cursor.Y <= 157 + 10 then
					DetermineColor(35)
					ColorName = Palette.ColNa35
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 157 and Cursor.Y <= 157 + 10 then
					DetermineColor(36)
					ColorName = Palette.ColNa36
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 169 and Cursor.Y <= 169 + 10 then
					DetermineColor(37)
					ColorName = Palette.ColNa37
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 169 and Cursor.Y <= 169 + 10 then
					DetermineColor(38)
					ColorName = Palette.ColNa38
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 169 and Cursor.Y <= 169 + 10 then
					DetermineColor(39)
					ColorName = Palette.ColNa39
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 169 and Cursor.Y <= 169 + 10 then
					DetermineColor(40)
					ColorName = Palette.ColNa40
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 181 and Cursor.Y <= 181 + 10 then
					DetermineColor(41)
					ColorName = Palette.ColNa41
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 181 and Cursor.Y <= 181 + 10 then
					DetermineColor(42)
					ColorName = Palette.ColNa42
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 181 and Cursor.Y <= 181 + 10 then
					DetermineColor(43)
					ColorName = Palette.ColNa43
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 181 and Cursor.Y <= 181 + 10 then
					DetermineColor(44)
					ColorName = Palette.ColNa44
				end
				
				
				
				if Cursor.X >= 3 and Cursor.X <= 3 + 10 and Cursor.Y >= 193 and Cursor.Y <= 193 + 10 then
					DetermineColor(45)
					ColorName = Palette.ColNa45
				end
				if Cursor.X >= 16 and Cursor.X <= 16 + 10 and Cursor.Y >= 193 and Cursor.Y <= 193 + 10 then
					DetermineColor(46)
					ColorName = Palette.ColNa46
				end
				if Cursor.X >= 29 and Cursor.X <= 29 + 10 and Cursor.Y >= 193 and Cursor.Y <= 193 + 10 then
					DetermineColor(47)
					ColorName = Palette.ColNa47
				end
				if Cursor.X >= 42 and Cursor.X <= 42 + 10 and Cursor.Y >= 193 and Cursor.Y <= 193 + 10 then
					DetermineColor(48)
					ColorName = Palette.ColNa48
				end
			end
		--end
		
		-- Locker
		-- 4,253
		
		
		-- Color Palette
		-- x1 = 3
		-- x2 = 16
		-- x3 = 29
		-- x4 = 42
		
		-- y1 = 61
		-- y2 = 73
		-- y3 = 85
		-- y4 = 97
		-- y5 = 109
		-- y6 = 121
		-- y7 = 
		
		-- 50
		-- 80
		-- 120
		-- 160
		-- 190
		-- 225
		
		if Cursor.X > 480 then Cursor.X = 0 end
		if Cursor.X < 0 then Cursor.X = 479 end
		if Cursor.Y > 272-1 then Cursor.Y = 0 end
		if Cursor.Y < 0 then Cursor.Y = 272-1 end
		
		screen:blit(Cursor.X, Cursor.Y, Cursor.IMG.Cursor)
		
	end
	
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	---------------------------------------------------------------------------------------------------------------------------------
	
	if pad:start() then dofile("MenuClass.lua") end
	
	if pad:select() then
		--if ScreenshotType == "HUD1" then
			TakeScreenshot()
		--elseif ScreenshotType == "NO_HUD" then
		--	IsSaving = true
		--end
	end
	
	if pad:start() then
		if pressed.start == false then
			pressed.start = true
			State = "Menu"
		end
	else
		pressed.start = false
	end
	
	screen.flip()
	screen.waitVblankStart()
end





